import { defineComponent as d, computed as f, openBlock as n, createElementBlock as a, normalizeClass as c, normalizeStyle as p, Fragment as b, createVNode as i, createElementVNode as u, toDisplayString as g, renderSlot as m } from "vue";
import { _ as y } from "./Loading.vue_vue_type_script_setup_true_lang-B8TZA-bM.js";
import { a as l } from "./color-nb3xs6hO.js";
const h = ["disabled", "type"], S = /* @__PURE__ */ d({
  __name: "Button",
  props: {
    type: { default: "normal" },
    disabled: { type: Boolean, default: !1 },
    htmlType: { default: "button" },
    block: { type: Boolean, default: !1 },
    circle: { type: Boolean, default: !1 },
    round: { type: Boolean, default: !1 },
    loadingText: { default: "加载中……" },
    loading: { type: Boolean, default: !1 },
    ghost: { type: Boolean, default: !1 },
    color: { default: void 0 },
    text: { type: Boolean, default: !1 }
  },
  setup(r) {
    const t = r, s = f(() => {
      if (t.color != null) {
        const e = l(t.color, 1, !0), o = l(t.color, 3, !1);
        return {
          "--nt-btn-border-color": t.text ? "transparent" : t.color,
          "--nt-btn-text-color": t.ghost || t.text ? t.color : "#ffffff",
          "--nt-btn-hover-text-color": t.ghost || t.text ? e : "#ffffff",
          "--nt-btn-background": t.ghost || t.text ? "transparent" : t.color,
          "--nt-btn-active-text-color": t.ghost || t.text ? o : "#ffffff",
          "--nt-btn-hover-border-color": t.text ? "transparent" : e,
          "--nt-btn-hover-background": t.ghost || t.text ? "transparent" : e,
          "--nt-btn-active-background": t.ghost || t.text ? "transparent" : o,
          "--nt-btn-active-border-color": t.text ? "transparent" : o
        };
      }
      return {};
    });
    return (e, o) => (n(), a("button", {
      class: c([
        "nt-btn",
        e.type ? "nt-btn-" + e.type : "",
        e.block ? "nt-btn-block" : "",
        e.round ? "nt-btn-round" : "",
        e.circle ? "nt-btn-circle" : "",
        e.loading ? "nt-btn-loading" : "",
        e.ghost ? "nt-btn-ghost" : "",
        e.text ? "nt-btn-text" : ""
      ]),
      disabled: e.disabled || e.loading,
      type: e.htmlType,
      style: p(s.value)
    }, [
      e.loading ? (n(), a(b, { key: 0 }, [
        i(y, { class: "nt-rotate-anim" }),
        u("span", null, g(e.loadingText), 1)
      ], 64)) : m(e.$slots, "default", { key: 1 })
    ], 14, h));
  }
});
export {
  S as _
};
