import { defineComponent as r, ref as c, computed as i, watch as p, provide as f, openBlock as m, createElementBlock as g, normalizeClass as v, normalizeStyle as y, renderSlot as h } from "vue";
import { collapseContext as b } from "./components/collapse/constant.js";
const x = /* @__PURE__ */ r({
  __name: "Collapse",
  props: {
    accordion: { type: Boolean, default: !1 },
    arrowPlacement: { default: "left" },
    headerJustify: { default: void 0 },
    background: { type: Boolean, default: !1 },
    gap: { default: void 0 },
    defaultExpandedNames: { default: () => [] },
    borderRadius: {},
    modelValue: { default: () => [] },
    grid: { type: Boolean, default: !1 }
  },
  emits: ["change", "update:modelValue"],
  setup(s, { emit: d }) {
    const e = s, t = d, a = c(e.modelValue), n = i(() => {
      const l = {};
      return e.gap != null && (l["--nt-collapse-gap"] = e.gap), e.borderRadius != null && (l["--nt-collapse-border-radius"] = e.borderRadius), l;
    });
    function u(l) {
      const o = a.value.indexOf(l);
      o === -1 ? e.accordion ? a.value = [l] : a.value.push(l) : a.value.splice(o, 1), t("update:modelValue", a.value), t("change", a.value);
    }
    return p(
      () => e.modelValue,
      (l) => {
        l != null && (a.value = l);
      }
    ), f(b, {
      arrowPlacement: e.arrowPlacement,
      headerJustify: e.headerJustify,
      actives: a,
      toggle: u
    }), (l, o) => (m(), g("div", {
      class: v(["nt-collapse", {
        "nt-collapse--background": e.background,
        "nt-collapse--space": e.gap != null,
        "nt-collapse--grid": e.grid
      }]),
      style: y(n.value)
    }, [
      h(l.$slots, "default")
    ], 6));
  }
});
export {
  x as _
};
