import { defineComponent as w, inject as k, computed as B, openBlock as n, createElementBlock as c, normalizeClass as s, unref as l, createElementVNode as r, normalizeStyle as x, createBlock as m, createCommentVNode as i, renderSlot as p, toDisplayString as E, createVNode as P, Transition as S, withCtx as $ } from "vue";
import { collapseContext as b } from "./components/collapse/constant.js";
import { q as N } from "./dom-DkwPuhdr.js";
import { _ as u } from "./ArrowRight.vue_vue_type_script_setup_true_lang-6j7wdDtx.js";
const j = { class: "nt-collapse-item__title" }, z = {
  key: 0,
  class: "nt-collapse-item--content"
}, L = { class: "nt-collapse-content--box" }, J = /* @__PURE__ */ w({
  __name: "CollapseItem",
  props: {
    title: {},
    name: {},
    disabled: { type: Boolean, default: !1 },
    headerClass: { default: "" }
  },
  setup(h) {
    function d(e) {
      e.style.height = "0px";
    }
    function f(e) {
      let o = N(e.innerHTML).height;
      e.style.height = `${o}px`;
    }
    function _(e) {
      e.style.removeProperty("height");
    }
    function y(e) {
      const o = e.getBoundingClientRect().height;
      e.style.height = `${o}px`;
    }
    function g(e) {
      e.style.height = "0px";
    }
    const a = h, t = k(b);
    if (t == null)
      throw new Error("CollapseItem must be used within Collapse");
    const v = B(() => {
      const e = {};
      return t.headerJustify != null && (e["justify-content"] = t.headerJustify), e;
    });
    function C() {
      t != null && t.toggle(a.name);
    }
    return (e, o) => (n(), c("div", {
      class: s(["nt-collapse-item", {
        "nt-collapse-item--active": l(t).actives.value.includes(
          a.name
        )
      }])
    }, [
      r("div", {
        class: s(["nt-collapse-item__header", e.headerClass]),
        style: x(v.value),
        onClick: C
      }, [
        l(t).arrowPlacement === "left" ? (n(), m(u, {
          key: 0,
          class: s(["nt-collapse-arrow-icon", ["nt-collapse-arrow__" + l(t).arrowPlacement]])
        }, null, 8, ["class"])) : i("", !0),
        p(e.$slots, "title", {}, () => [
          r("span", j, E(e.title), 1)
        ]),
        l(t).arrowPlacement === "right" ? (n(), m(u, {
          key: 1,
          class: s(["nt-collapse-arrow-icon", ["nt-collapse-arrow__" + l(t).arrowPlacement]])
        }, null, 8, ["class"])) : i("", !0)
      ], 6),
      P(S, {
        name: "collapse",
        onBeforeEnter: d,
        onEnter: f,
        onAfterEnter: _,
        onBeforeLeave: y,
        onLeave: g
      }, {
        default: $(() => [
          l(t).actives.value.includes(a.name) ? (n(), c("div", z, [
            r("div", L, [
              p(e.$slots, "default")
            ])
          ])) : i("", !0)
        ]),
        _: 3
      })
    ], 2));
  }
});
export {
  J as _
};
