import { defineComponent as Bt, ref as j, withDirectives as mt, h as B, Teleport as Nt, Transition as Vt, vShow as $t, nextTick as Mt } from "vue";
import { popoverProps as Wt } from "./components/popover/constant.js";
import { u as Ht } from "./useDebounce-C-3_Pz1n.js";
import _t from "./directives/clickoutside.js";
const nt = Math.min, N = Math.max, K = Math.round, R = (t) => ({
  x: t,
  y: t
}), jt = {
  left: "right",
  right: "left",
  bottom: "top",
  top: "bottom"
}, Yt = {
  start: "end",
  end: "start"
};
function ht(t, e, o) {
  return N(t, nt(e, o));
}
function G(t, e) {
  return typeof t == "function" ? t(e) : t;
}
function P(t) {
  return t.split("-")[0];
}
function J(t) {
  return t.split("-")[1];
}
function vt(t) {
  return t === "x" ? "y" : "x";
}
function bt(t) {
  return t === "y" ? "height" : "width";
}
function $(t) {
  return ["top", "bottom"].includes(P(t)) ? "y" : "x";
}
function At(t) {
  return vt($(t));
}
function Xt(t, e, o) {
  o === void 0 && (o = !1);
  const n = J(t), i = At(t), s = bt(i);
  let r = i === "x" ? n === (o ? "end" : "start") ? "right" : "left" : n === "start" ? "bottom" : "top";
  return e.reference[s] > e.floating[s] && (r = q(r)), [r, q(r)];
}
function It(t) {
  const e = q(t);
  return [ot(t), e, ot(e)];
}
function ot(t) {
  return t.replace(/start|end/g, (e) => Yt[e]);
}
function Kt(t, e, o) {
  const n = ["left", "right"], i = ["right", "left"], s = ["top", "bottom"], r = ["bottom", "top"];
  switch (t) {
    case "top":
    case "bottom":
      return o ? e ? i : n : e ? n : i;
    case "left":
    case "right":
      return e ? s : r;
    default:
      return [];
  }
}
function qt(t, e, o, n) {
  const i = J(t);
  let s = Kt(P(t), o === "start", n);
  return i && (s = s.map((r) => r + "-" + i), e && (s = s.concat(s.map(ot)))), s;
}
function q(t) {
  return t.replace(/left|right|bottom|top/g, (e) => jt[e]);
}
function zt(t) {
  return {
    top: 0,
    right: 0,
    bottom: 0,
    left: 0,
    ...t
  };
}
function Gt(t) {
  return typeof t != "number" ? zt(t) : {
    top: t,
    right: t,
    bottom: t,
    left: t
  };
}
function z(t) {
  const {
    x: e,
    y: o,
    width: n,
    height: i
  } = t;
  return {
    width: n,
    height: i,
    top: o,
    left: e,
    right: e + n,
    bottom: o + i,
    x: e,
    y: o
  };
}
function pt(t, e, o) {
  let {
    reference: n,
    floating: i
  } = t;
  const s = $(e), r = At(e), c = bt(r), l = P(e), f = s === "y", a = n.x + n.width / 2 - i.width / 2, u = n.y + n.height / 2 - i.height / 2, g = n[c] / 2 - i[c] / 2;
  let d;
  switch (l) {
    case "top":
      d = {
        x: a,
        y: n.y - i.height
      };
      break;
    case "bottom":
      d = {
        x: a,
        y: n.y + n.height
      };
      break;
    case "right":
      d = {
        x: n.x + n.width,
        y: u
      };
      break;
    case "left":
      d = {
        x: n.x - i.width,
        y: u
      };
      break;
    default:
      d = {
        x: n.x,
        y: n.y
      };
  }
  switch (J(e)) {
    case "start":
      d[r] -= g * (o && f ? -1 : 1);
      break;
    case "end":
      d[r] += g * (o && f ? -1 : 1);
      break;
  }
  return d;
}
const Jt = async (t, e, o) => {
  const {
    placement: n = "bottom",
    strategy: i = "absolute",
    middleware: s = [],
    platform: r
  } = o, c = s.filter(Boolean), l = await (r.isRTL == null ? void 0 : r.isRTL(e));
  let f = await r.getElementRects({
    reference: t,
    floating: e,
    strategy: i
  }), {
    x: a,
    y: u
  } = pt(f, n, l), g = n, d = {}, m = 0;
  for (let w = 0; w < c.length; w++) {
    const {
      name: h,
      fn: x
    } = c[w], {
      x: p,
      y,
      data: b,
      reset: v
    } = await x({
      x: a,
      y: u,
      initialPlacement: n,
      placement: g,
      strategy: i,
      middlewareData: d,
      rects: f,
      platform: r,
      elements: {
        reference: t,
        floating: e
      }
    });
    a = p ?? a, u = y ?? u, d = {
      ...d,
      [h]: {
        ...d[h],
        ...b
      }
    }, v && m <= 50 && (m++, typeof v == "object" && (v.placement && (g = v.placement), v.rects && (f = v.rects === !0 ? await r.getElementRects({
      reference: t,
      floating: e,
      strategy: i
    }) : v.rects), {
      x: a,
      y: u
    } = pt(f, g, l)), w = -1);
  }
  return {
    x: a,
    y: u,
    placement: g,
    strategy: i,
    middlewareData: d
  };
};
async function Ct(t, e) {
  var o;
  e === void 0 && (e = {});
  const {
    x: n,
    y: i,
    platform: s,
    rects: r,
    elements: c,
    strategy: l
  } = t, {
    boundary: f = "clippingAncestors",
    rootBoundary: a = "viewport",
    elementContext: u = "floating",
    altBoundary: g = !1,
    padding: d = 0
  } = G(e, t), m = Gt(d), h = c[g ? u === "floating" ? "reference" : "floating" : u], x = z(await s.getClippingRect({
    element: (o = await (s.isElement == null ? void 0 : s.isElement(h))) == null || o ? h : h.contextElement || await (s.getDocumentElement == null ? void 0 : s.getDocumentElement(c.floating)),
    boundary: f,
    rootBoundary: a,
    strategy: l
  })), p = u === "floating" ? {
    x: n,
    y: i,
    width: r.floating.width,
    height: r.floating.height
  } : r.reference, y = await (s.getOffsetParent == null ? void 0 : s.getOffsetParent(c.floating)), b = await (s.isElement == null ? void 0 : s.isElement(y)) ? await (s.getScale == null ? void 0 : s.getScale(y)) || {
    x: 1,
    y: 1
  } : {
    x: 1,
    y: 1
  }, v = z(s.convertOffsetParentRelativeRectToViewportRelativeRect ? await s.convertOffsetParentRelativeRectToViewportRelativeRect({
    elements: c,
    rect: p,
    offsetParent: y,
    strategy: l
  }) : p);
  return {
    top: (x.top - v.top + m.top) / b.y,
    bottom: (v.bottom - x.bottom + m.bottom) / b.y,
    left: (x.left - v.left + m.left) / b.x,
    right: (v.right - x.right + m.right) / b.x
  };
}
const Qt = function(t) {
  return t === void 0 && (t = {}), {
    name: "flip",
    options: t,
    async fn(e) {
      var o, n;
      const {
        placement: i,
        middlewareData: s,
        rects: r,
        initialPlacement: c,
        platform: l,
        elements: f
      } = e, {
        mainAxis: a = !0,
        crossAxis: u = !0,
        fallbackPlacements: g,
        fallbackStrategy: d = "bestFit",
        fallbackAxisSideDirection: m = "none",
        flipAlignment: w = !0,
        ...h
      } = G(t, e);
      if ((o = s.arrow) != null && o.alignmentOffset)
        return {};
      const x = P(i), p = $(c), y = P(c) === c, b = await (l.isRTL == null ? void 0 : l.isRTL(f.floating)), v = g || (y || !w ? [q(c)] : It(c)), ft = m !== "none";
      !g && ft && v.push(...qt(c, w, m, b));
      const Pt = [c, ...v], tt = await Ct(e, h), I = [];
      let H = ((n = s.flip) == null ? void 0 : n.overflows) || [];
      if (a && I.push(tt[x]), u) {
        const D = Xt(i, r, b);
        I.push(tt[D[0]], tt[D[1]]);
      }
      if (H = [...H, {
        placement: i,
        overflows: I
      }], !I.every((D) => D <= 0)) {
        var at, ut;
        const D = (((at = s.flip) == null ? void 0 : at.index) || 0) + 1, gt = Pt[D];
        if (gt)
          return {
            data: {
              index: D,
              overflows: H
            },
            reset: {
              placement: gt
            }
          };
        let _ = (ut = H.filter((F) => F.overflows[0] <= 0).sort((F, E) => F.overflows[1] - E.overflows[1])[0]) == null ? void 0 : ut.placement;
        if (!_)
          switch (d) {
            case "bestFit": {
              var dt;
              const F = (dt = H.filter((E) => {
                if (ft) {
                  const k = $(E.placement);
                  return k === p || // Create a bias to the `y` side axis due to horizontal
                  // reading directions favoring greater width.
                  k === "y";
                }
                return !0;
              }).map((E) => [E.placement, E.overflows.filter((k) => k > 0).reduce((k, Ft) => k + Ft, 0)]).sort((E, k) => E[1] - k[1])[0]) == null ? void 0 : dt[0];
              F && (_ = F);
              break;
            }
            case "initialPlacement":
              _ = c;
              break;
          }
        if (i !== _)
          return {
            reset: {
              placement: _
            }
          };
      }
      return {};
    }
  };
};
async function Ut(t, e) {
  const {
    placement: o,
    platform: n,
    elements: i
  } = t, s = await (n.isRTL == null ? void 0 : n.isRTL(i.floating)), r = P(o), c = J(o), l = $(o) === "y", f = ["left", "top"].includes(r) ? -1 : 1, a = s && l ? -1 : 1, u = G(e, t);
  let {
    mainAxis: g,
    crossAxis: d,
    alignmentAxis: m
  } = typeof u == "number" ? {
    mainAxis: u,
    crossAxis: 0,
    alignmentAxis: null
  } : {
    mainAxis: u.mainAxis || 0,
    crossAxis: u.crossAxis || 0,
    alignmentAxis: u.alignmentAxis
  };
  return c && typeof m == "number" && (d = c === "end" ? m * -1 : m), l ? {
    x: d * a,
    y: g * f
  } : {
    x: g * f,
    y: d * a
  };
}
const Zt = function(t) {
  return t === void 0 && (t = 0), {
    name: "offset",
    options: t,
    async fn(e) {
      var o, n;
      const {
        x: i,
        y: s,
        placement: r,
        middlewareData: c
      } = e, l = await Ut(e, t);
      return r === ((o = c.offset) == null ? void 0 : o.placement) && (n = c.arrow) != null && n.alignmentOffset ? {} : {
        x: i + l.x,
        y: s + l.y,
        data: {
          ...l,
          placement: r
        }
      };
    }
  };
}, te = function(t) {
  return t === void 0 && (t = {}), {
    name: "shift",
    options: t,
    async fn(e) {
      const {
        x: o,
        y: n,
        placement: i
      } = e, {
        mainAxis: s = !0,
        crossAxis: r = !1,
        limiter: c = {
          fn: (h) => {
            let {
              x,
              y: p
            } = h;
            return {
              x,
              y: p
            };
          }
        },
        ...l
      } = G(t, e), f = {
        x: o,
        y: n
      }, a = await Ct(e, l), u = $(P(i)), g = vt(u);
      let d = f[g], m = f[u];
      if (s) {
        const h = g === "y" ? "top" : "left", x = g === "y" ? "bottom" : "right", p = d + a[h], y = d - a[x];
        d = ht(p, d, y);
      }
      if (r) {
        const h = u === "y" ? "top" : "left", x = u === "y" ? "bottom" : "right", p = m + a[h], y = m - a[x];
        m = ht(p, m, y);
      }
      const w = c.fn({
        ...e,
        [g]: d,
        [u]: m
      });
      return {
        ...w,
        data: {
          x: w.x - o,
          y: w.y - n,
          enabled: {
            [g]: s,
            [u]: r
          }
        }
      };
    }
  };
};
function Q() {
  return typeof window < "u";
}
function W(t) {
  return Tt(t) ? (t.nodeName || "").toLowerCase() : "#document";
}
function A(t) {
  var e;
  return (t == null || (e = t.ownerDocument) == null ? void 0 : e.defaultView) || window;
}
function L(t) {
  var e;
  return (e = (Tt(t) ? t.ownerDocument : t.document) || window.document) == null ? void 0 : e.documentElement;
}
function Tt(t) {
  return Q() ? t instanceof Node || t instanceof A(t).Node : !1;
}
function C(t) {
  return Q() ? t instanceof Element || t instanceof A(t).Element : !1;
}
function O(t) {
  return Q() ? t instanceof HTMLElement || t instanceof A(t).HTMLElement : !1;
}
function wt(t) {
  return !Q() || typeof ShadowRoot > "u" ? !1 : t instanceof ShadowRoot || t instanceof A(t).ShadowRoot;
}
function X(t) {
  const {
    overflow: e,
    overflowX: o,
    overflowY: n,
    display: i
  } = T(t);
  return /auto|scroll|overlay|hidden|clip/.test(e + n + o) && !["inline", "contents"].includes(i);
}
function ee(t) {
  return ["table", "td", "th"].includes(W(t));
}
function U(t) {
  return [":popover-open", ":modal"].some((e) => {
    try {
      return t.matches(e);
    } catch {
      return !1;
    }
  });
}
function st(t) {
  const e = ct(), o = C(t) ? T(t) : t;
  return o.transform !== "none" || o.perspective !== "none" || (o.containerType ? o.containerType !== "normal" : !1) || !e && (o.backdropFilter ? o.backdropFilter !== "none" : !1) || !e && (o.filter ? o.filter !== "none" : !1) || ["transform", "perspective", "filter"].some((n) => (o.willChange || "").includes(n)) || ["paint", "layout", "strict", "content"].some((n) => (o.contain || "").includes(n));
}
function ne(t) {
  let e = S(t);
  for (; O(e) && !M(e); ) {
    if (st(e))
      return e;
    if (U(e))
      return null;
    e = S(e);
  }
  return null;
}
function ct() {
  return typeof CSS > "u" || !CSS.supports ? !1 : CSS.supports("-webkit-backdrop-filter", "none");
}
function M(t) {
  return ["html", "body", "#document"].includes(W(t));
}
function T(t) {
  return A(t).getComputedStyle(t);
}
function Z(t) {
  return C(t) ? {
    scrollLeft: t.scrollLeft,
    scrollTop: t.scrollTop
  } : {
    scrollLeft: t.scrollX,
    scrollTop: t.scrollY
  };
}
function S(t) {
  if (W(t) === "html")
    return t;
  const e = (
    // Step into the shadow DOM of the parent of a slotted node.
    t.assignedSlot || // DOM Element detected.
    t.parentNode || // ShadowRoot detected.
    wt(t) && t.host || // Fallback.
    L(t)
  );
  return wt(e) ? e.host : e;
}
function Rt(t) {
  const e = S(t);
  return M(e) ? t.ownerDocument ? t.ownerDocument.body : t.body : O(e) && X(e) ? e : Rt(e);
}
function it(t, e, o) {
  var n;
  e === void 0 && (e = []), o === void 0 && (o = !0);
  const i = Rt(t), s = i === ((n = t.ownerDocument) == null ? void 0 : n.body), r = A(i);
  if (s) {
    const c = rt(r);
    return e.concat(r, r.visualViewport || [], X(i) ? i : [], c && o ? it(c) : []);
  }
  return e.concat(i, it(i, [], o));
}
function rt(t) {
  return t.parent && Object.getPrototypeOf(t.parent) ? t.frameElement : null;
}
function Ot(t) {
  const e = T(t);
  let o = parseFloat(e.width) || 0, n = parseFloat(e.height) || 0;
  const i = O(t), s = i ? t.offsetWidth : o, r = i ? t.offsetHeight : n, c = K(o) !== s || K(n) !== r;
  return c && (o = s, n = r), {
    width: o,
    height: n,
    $: c
  };
}
function Lt(t) {
  return C(t) ? t : t.contextElement;
}
function V(t) {
  const e = Lt(t);
  if (!O(e))
    return R(1);
  const o = e.getBoundingClientRect(), {
    width: n,
    height: i,
    $: s
  } = Ot(e);
  let r = (s ? K(o.width) : o.width) / n, c = (s ? K(o.height) : o.height) / i;
  return (!r || !Number.isFinite(r)) && (r = 1), (!c || !Number.isFinite(c)) && (c = 1), {
    x: r,
    y: c
  };
}
const oe = /* @__PURE__ */ R(0);
function Et(t) {
  const e = A(t);
  return !ct() || !e.visualViewport ? oe : {
    x: e.visualViewport.offsetLeft,
    y: e.visualViewport.offsetTop
  };
}
function ie(t, e, o) {
  return e === void 0 && (e = !1), !o || e && o !== A(t) ? !1 : e;
}
function Y(t, e, o, n) {
  e === void 0 && (e = !1), o === void 0 && (o = !1);
  const i = t.getBoundingClientRect(), s = Lt(t);
  let r = R(1);
  e && (n ? C(n) && (r = V(n)) : r = V(t));
  const c = ie(s, o, n) ? Et(s) : R(0);
  let l = (i.left + c.x) / r.x, f = (i.top + c.y) / r.y, a = i.width / r.x, u = i.height / r.y;
  if (s) {
    const g = A(s), d = n && C(n) ? A(n) : n;
    let m = g, w = rt(m);
    for (; w && n && d !== m; ) {
      const h = V(w), x = w.getBoundingClientRect(), p = T(w), y = x.left + (w.clientLeft + parseFloat(p.paddingLeft)) * h.x, b = x.top + (w.clientTop + parseFloat(p.paddingTop)) * h.y;
      l *= h.x, f *= h.y, a *= h.x, u *= h.y, l += y, f += b, m = A(w), w = rt(m);
    }
  }
  return z({
    width: a,
    height: u,
    x: l,
    y: f
  });
}
function lt(t, e) {
  const o = Z(t).scrollLeft;
  return e ? e.left + o : Y(L(t)).left + o;
}
function kt(t, e, o) {
  o === void 0 && (o = !1);
  const n = t.getBoundingClientRect(), i = n.left + e.scrollLeft - (o ? 0 : (
    // RTL <body> scrollbar.
    lt(t, n)
  )), s = n.top + e.scrollTop;
  return {
    x: i,
    y: s
  };
}
function re(t) {
  let {
    elements: e,
    rect: o,
    offsetParent: n,
    strategy: i
  } = t;
  const s = i === "fixed", r = L(n), c = e ? U(e.floating) : !1;
  if (n === r || c && s)
    return o;
  let l = {
    scrollLeft: 0,
    scrollTop: 0
  }, f = R(1);
  const a = R(0), u = O(n);
  if ((u || !u && !s) && ((W(n) !== "body" || X(r)) && (l = Z(n)), O(n))) {
    const d = Y(n);
    f = V(n), a.x = d.x + n.clientLeft, a.y = d.y + n.clientTop;
  }
  const g = r && !u && !s ? kt(r, l, !0) : R(0);
  return {
    width: o.width * f.x,
    height: o.height * f.y,
    x: o.x * f.x - l.scrollLeft * f.x + a.x + g.x,
    y: o.y * f.y - l.scrollTop * f.y + a.y + g.y
  };
}
function se(t) {
  return Array.from(t.getClientRects());
}
function ce(t) {
  const e = L(t), o = Z(t), n = t.ownerDocument.body, i = N(e.scrollWidth, e.clientWidth, n.scrollWidth, n.clientWidth), s = N(e.scrollHeight, e.clientHeight, n.scrollHeight, n.clientHeight);
  let r = -o.scrollLeft + lt(t);
  const c = -o.scrollTop;
  return T(n).direction === "rtl" && (r += N(e.clientWidth, n.clientWidth) - i), {
    width: i,
    height: s,
    x: r,
    y: c
  };
}
function le(t, e) {
  const o = A(t), n = L(t), i = o.visualViewport;
  let s = n.clientWidth, r = n.clientHeight, c = 0, l = 0;
  if (i) {
    s = i.width, r = i.height;
    const f = ct();
    (!f || f && e === "fixed") && (c = i.offsetLeft, l = i.offsetTop);
  }
  return {
    width: s,
    height: r,
    x: c,
    y: l
  };
}
function fe(t, e) {
  const o = Y(t, !0, e === "fixed"), n = o.top + t.clientTop, i = o.left + t.clientLeft, s = O(t) ? V(t) : R(1), r = t.clientWidth * s.x, c = t.clientHeight * s.y, l = i * s.x, f = n * s.y;
  return {
    width: r,
    height: c,
    x: l,
    y: f
  };
}
function xt(t, e, o) {
  let n;
  if (e === "viewport")
    n = le(t, o);
  else if (e === "document")
    n = ce(L(t));
  else if (C(e))
    n = fe(e, o);
  else {
    const i = Et(t);
    n = {
      x: e.x - i.x,
      y: e.y - i.y,
      width: e.width,
      height: e.height
    };
  }
  return z(n);
}
function St(t, e) {
  const o = S(t);
  return o === e || !C(o) || M(o) ? !1 : T(o).position === "fixed" || St(o, e);
}
function ae(t, e) {
  const o = e.get(t);
  if (o)
    return o;
  let n = it(t, [], !1).filter((c) => C(c) && W(c) !== "body"), i = null;
  const s = T(t).position === "fixed";
  let r = s ? S(t) : t;
  for (; C(r) && !M(r); ) {
    const c = T(r), l = st(r);
    !l && c.position === "fixed" && (i = null), (s ? !l && !i : !l && c.position === "static" && !!i && ["absolute", "fixed"].includes(i.position) || X(r) && !l && St(t, r)) ? n = n.filter((a) => a !== r) : i = c, r = S(r);
  }
  return e.set(t, n), n;
}
function ue(t) {
  let {
    element: e,
    boundary: o,
    rootBoundary: n,
    strategy: i
  } = t;
  const r = [...o === "clippingAncestors" ? U(e) ? [] : ae(e, this._c) : [].concat(o), n], c = r[0], l = r.reduce((f, a) => {
    const u = xt(e, a, i);
    return f.top = N(u.top, f.top), f.right = nt(u.right, f.right), f.bottom = nt(u.bottom, f.bottom), f.left = N(u.left, f.left), f;
  }, xt(e, c, i));
  return {
    width: l.right - l.left,
    height: l.bottom - l.top,
    x: l.left,
    y: l.top
  };
}
function de(t) {
  const {
    width: e,
    height: o
  } = Ot(t);
  return {
    width: e,
    height: o
  };
}
function ge(t, e, o) {
  const n = O(e), i = L(e), s = o === "fixed", r = Y(t, !0, s, e);
  let c = {
    scrollLeft: 0,
    scrollTop: 0
  };
  const l = R(0);
  if (n || !n && !s)
    if ((W(e) !== "body" || X(i)) && (c = Z(e)), n) {
      const g = Y(e, !0, s, e);
      l.x = g.x + e.clientLeft, l.y = g.y + e.clientTop;
    } else i && (l.x = lt(i));
  const f = i && !n && !s ? kt(i, c) : R(0), a = r.left + c.scrollLeft - l.x - f.x, u = r.top + c.scrollTop - l.y - f.y;
  return {
    x: a,
    y: u,
    width: r.width,
    height: r.height
  };
}
function et(t) {
  return T(t).position === "static";
}
function yt(t, e) {
  if (!O(t) || T(t).position === "fixed")
    return null;
  if (e)
    return e(t);
  let o = t.offsetParent;
  return L(t) === o && (o = o.ownerDocument.body), o;
}
function Dt(t, e) {
  const o = A(t);
  if (U(t))
    return o;
  if (!O(t)) {
    let i = S(t);
    for (; i && !M(i); ) {
      if (C(i) && !et(i))
        return i;
      i = S(i);
    }
    return o;
  }
  let n = yt(t, e);
  for (; n && ee(n) && et(n); )
    n = yt(n, e);
  return n && M(n) && et(n) && !st(n) ? o : n || ne(t) || o;
}
const me = async function(t) {
  const e = this.getOffsetParent || Dt, o = this.getDimensions, n = await o(t.floating);
  return {
    reference: ge(t.reference, await e(t.floating), t.strategy),
    floating: {
      x: 0,
      y: 0,
      width: n.width,
      height: n.height
    }
  };
};
function he(t) {
  return T(t).direction === "rtl";
}
const pe = {
  convertOffsetParentRelativeRectToViewportRelativeRect: re,
  getDocumentElement: L,
  getClippingRect: ue,
  getOffsetParent: Dt,
  getElementRects: me,
  getClientRects: se,
  getDimensions: de,
  getScale: V,
  isElement: C,
  isRTL: he
}, we = Zt, xe = te, ye = Qt, ve = (t, e, o) => {
  const n = /* @__PURE__ */ new Map(), i = {
    platform: pe,
    ...o
  }, s = {
    ...i.platform,
    _c: n
  };
  return Jt(t, e, {
    ...i,
    platform: s
  });
}, Re = Bt({
  name: "FloatingPopover",
  props: Wt,
  setup(t, { slots: e, attrs: o }) {
    const n = j(!1), i = j(t.placement), s = j(), r = j(), c = j({}), { run: l, cancel: f } = Ht(
      () => n.value = !1,
      100
    ), a = {};
    t.trigger === "hover" ? (a.onMouseleave = g, a.onMouseenter = d) : t.trigger === "click" ? a.onClick = u : t.trigger === "focus" && (a.onFocus = m, a.onBlur = w);
    function u(p) {
      p.currentTarget.classList.contains("nt-popover") ? f() : n.value ? n.value = !1 : h(p.target);
    }
    function g() {
      l();
    }
    function d(p) {
      h(p.target);
    }
    function m(p) {
      h(p.target);
    }
    function w() {
      l();
    }
    function h(p) {
      if (n.value) {
        f();
        return;
      }
      p.classList.contains("nt-popover") || (n.value = !0, Mt(() => {
        s.value && r.value && ve(s.value, r.value, {
          placement: t.placement,
          middleware: [
            we(6 - (t.showArrow ? 0 : 4)),
            ye(),
            xe({ padding: 5 })
          ]
        }).then(({ x: y, y: b, placement: v }) => {
          c.value = {
            left: `${y}px`,
            top: `${b}px`
          }, i.value = v;
        });
      }));
    }
    function x() {
      l();
    }
    return () => [
      e.trigger != null ? t.trigger === "click" ? mt(
        B(e.trigger()[0], { ...a, ref: s }),
        [[_t, x]]
      ) : B(e.trigger()[0], { ...a, ref: s }) : null,
      B(
        Nt,
        { to: "body" },
        B(
          Vt,
          { name: "nt-opacity" },
          {
            default: () => mt(
              B(
                "div",
                {
                  class: [
                    "nt-popover",
                    `nt-popover-${i.value}`,
                    o.class
                  ],
                  style: c.value,
                  ...a,
                  ref: r
                },
                [
                  e.default != null ? e.default() : void 0,
                  t.showArrow ? B("span", { class: "nt-popover-arrow" }) : null
                ]
              ),
              [[$t, n.value]]
            )
          }
        )
      )
    ];
  }
});
export {
  Re as _
};
