import { defineComponent as w, ref as C, computed as _, watch as I, openBlock as o, createElementBlock as v, normalizeClass as d, createElementVNode as s, createVNode as m, withCtx as h, withKeys as V, toDisplayString as $, Fragment as P, createBlock as c, createCommentVNode as p, renderList as z } from "vue";
import { _ as N } from "./Button.vue_vue_type_script_setup_true_lang-CotO76QS.js";
import { _ as E } from "./ArrowLeft.vue_vue_type_script_setup_true_lang-DLHhQ5In.js";
import { _ as F } from "./ArrowRight.vue_vue_type_script_setup_true_lang-6j7wdDtx.js";
import { _ as b } from "./More.vue_vue_type_script_setup_true_lang-DrwjH9WE.js";
import { _ as K } from "./DArrowLeft.vue_vue_type_script_setup_true_lang-PyqfaNhF.js";
import { _ as O } from "./DArrowRight.vue_vue_type_script_setup_true_lang-BiHRBIH2.js";
const x = { class: "nt-pagination-item" }, D = {
  key: 0,
  class: "nt-pagination-item nt-pagination-simple-layout"
}, H = ["value"], L = {
  key: 0,
  class: "nt-pagination-item"
}, R = ["title", "onClick"], T = {
  key: 1,
  class: "nt-pagination-item"
}, q = ["title"], A = { class: "nt-pagination-item" }, Z = /* @__PURE__ */ w({
  __name: "Pagination",
  props: {
    total: {},
    pageCount: {},
    pageSize: { default: 10 },
    page: {},
    defaultCurrentPage: { default: 1 },
    align: { default: "start" },
    hideOnSinglePage: { type: Boolean, default: !1 },
    simple: { type: Boolean, default: !1 }
  },
  emits: ["update:page", "change"],
  setup(S, { emit: M }) {
    const g = C(0), u = S, k = M, l = _(() => {
      let e = u.pageCount;
      return e == null && u.total != null && (e = Math.ceil(u.total / u.pageSize)), (e == null || e <= 0) && (e = 1), e;
    }), i = C(u.page || u.defaultCurrentPage), B = _(() => {
      let e = i.value - 2;
      const t = i.value + 5, a = [];
      for (let n = e; n <= t && (n > 1 && n < l.value && a.push(n), a.length !== 5); n++)
        ;
      for (; a.length < 5 && e > 1; ) {
        const n = e--;
        a.includes(n) || a.unshift(n);
      }
      return a;
    });
    u.page == null && k("update:page", i.value), I(
      () => u.page,
      (e) => {
        const t = e || u.defaultCurrentPage;
        t !== i.value && (i.value = t);
      }
    );
    function f(e) {
      g.value = e;
    }
    function r(e) {
      e < 1 ? e = 1 : e > l.value && (e = l.value), e !== i.value && (i.value = e, k("update:page", e), k("change", e));
    }
    function j(e) {
      const t = e.target, a = t.value;
      let n = parseInt(a, 10);
      Number.isNaN(n) ? n = "" : (n = Math.abs(n), n < 1 ? n = 1 : n > l.value && (n = l.value)), n = String(n), n !== a && (t.value = n);
    }
    function y(e) {
      const a = e.target.value, n = parseInt(a, 10);
      Number.isNaN(n) || r(n);
    }
    return (e, t) => !e.hideOnSinglePage || l.value > 1 ? (o(), v("ul", {
      key: 0,
      class: d(["nt-pagination", `nt-pagination-${e.align}`])
    }, [
      s("li", x, [
        m(N, {
          title: "上一页",
          disabled: i.value === 1,
          onClick: t[0] || (t[0] = (a) => r(i.value - 1))
        }, {
          default: h(() => [
            m(E)
          ]),
          _: 1
        }, 8, ["disabled"])
      ]),
      e.simple ? (o(), v("li", D, [
        s("input", {
          class: "nt-input nt-pagination-simple-input",
          value: i.value,
          type: "text",
          inputmode: "numeric",
          onInput: j,
          onKeyup: V(y, ["enter"]),
          onBlur: y
        }, null, 40, H),
        t[10] || (t[10] = s("span", { class: "nt-pagination-simple-divide" }, "/", -1)),
        s("span", null, $(l.value), 1)
      ])) : (o(), v(P, { key: 1 }, [
        s("li", {
          class: d(["nt-pagination-item", i.value === 1 ? "is-active" : ""])
        }, [
          s("a", {
            href: "javascript:void(0)",
            title: "1",
            onClick: t[1] || (t[1] = (a) => r(1))
          }, "1")
        ], 2),
        i.value > 4 ? (o(), v("li", L, [
          s("a", {
            href: "javascript:void(0)",
            onMouseenter: t[2] || (t[2] = (a) => f(1)),
            onMouseleave: t[3] || (t[3] = (a) => f(0)),
            title: "向前5页",
            onClick: t[4] || (t[4] = (a) => r(i.value - 5))
          }, [
            g.value !== 1 ? (o(), c(b, { key: 0 })) : g.value === 1 ? (o(), c(K, { key: 1 })) : p("", !0)
          ], 32)
        ])) : p("", !0),
        (o(!0), v(P, null, z(B.value, (a) => (o(), v("li", {
          key: a,
          class: d(["nt-pagination-item", i.value === a ? "is-active" : ""])
        }, [
          s("a", {
            href: "javascript:void(0)",
            title: String(a),
            onClick: (n) => r(a)
          }, $(a), 9, R)
        ], 2))), 128)),
        i.value < l.value - 3 ? (o(), v("li", T, [
          s("a", {
            href: "javascript:void(0)",
            onMouseenter: t[5] || (t[5] = (a) => f(2)),
            onMouseleave: t[6] || (t[6] = (a) => f(0)),
            title: "向前5页",
            onClick: t[7] || (t[7] = (a) => r(i.value + 5))
          }, [
            g.value !== 2 ? (o(), c(b, { key: 0 })) : g.value === 2 ? (o(), c(O, { key: 1 })) : p("", !0)
          ], 32)
        ])) : p("", !0),
        l.value > 1 ? (o(), v("li", {
          key: 2,
          onClick: t[8] || (t[8] = (a) => r(l.value)),
          class: d([
            "nt-pagination-item",
            i.value === l.value ? "is-active" : ""
          ])
        }, [
          s("a", {
            href: "javascript:void(0)",
            title: l.value + ""
          }, $(l.value), 9, q)
        ], 2)) : p("", !0)
      ], 64)),
      s("li", A, [
        m(N, {
          title: "下一页",
          disabled: i.value === l.value,
          onClick: t[9] || (t[9] = (a) => r(i.value + 1))
        }, {
          default: h(() => [
            m(F)
          ]),
          _: 1
        }, 8, ["disabled"])
      ])
    ], 2)) : p("", !0);
  }
});
export {
  Z as _
};
