import { defineComponent as h, ref as v, inject as b, computed as m, h as l } from "vue";
const s = h({
  props: {
    name: {
      type: String,
      default: void 0
    },
    value: {
      type: [String, Boolean, Number],
      default: void 0
    },
    disabled: {
      type: Boolean,
      default: !1
    },
    label: String,
    type: {
      type: String,
      default: void 0
    },
    modelValue: {
      type: Boolean,
      default: !1
    },
    checked: { type: Boolean, default: void 0 }
  },
  emits: ["change", "update:modelValue"],
  setup(e, { emit: t, slots: a }) {
    const i = v(), { checkedValue: n, updateCheck: u } = b("nt-radio-group-check", {
      checkedValue: null,
      updateCheck: null
    }), d = m(() => n != null ? n.value === e.value : e.value != null ? e.modelValue === e.value : e.checked != null ? e.checked : e.modelValue);
    function o(f) {
      const r = f.target.checked;
      u != null && u(e.value);
      const c = e.value == null ? r : e.value;
      t("update:modelValue", c), t("change", c);
    }
    return () => l(
      "label",
      {
        class: {
          "nt-radio": !0,
          "nt-radio--disabled": e.disabled,
          "nt-radio--button": e.type === "button",
          "is-checked": d.value
        }
      },
      [
        l("input", {
          ref: i,
          type: "radio",
          name: e.name,
          class: "nt-radio__input",
          value: e.value,
          disabled: e.disabled,
          checked: d.value,
          onChange: o
        }),
        e.type !== "button" ? l("span", { class: "nt-radio__inner" }) : null,
        a.default != null || e.label != null ? l("span", { class: "nt-radio__label" }, [
          a.default != null ? a.default() : e.label
        ]) : null
      ]
    );
  }
});
export {
  s as _
};
