import { defineComponent as V, shallowRef as k, computed as z, openBlock as d, createElementBlock as u, createElementVNode as g, normalizeClass as _, normalizeStyle as C, Fragment as f, renderList as h, unref as m, createVNode as R, createCommentVNode as v, h as c } from "vue";
import { useVueTable as A, getCoreRowModel as N, getSortedRowModel as D, getExpandedRowModel as j, FlexRender as I } from "@tanstack/vue-table";
import { _ as O } from "./Radio.vue_vue_type_script_lang-B943p2-7.js";
import M from "./components/checkbox/Checkbox.js";
import { _ as L } from "./Button.vue_vue_type_script_setup_true_lang-CotO76QS.js";
import { _ as T } from "./ArrowRight.vue_vue_type_script_setup_true_lang-6j7wdDtx.js";
const q = { class: "nt-table-wrapper nt-scrollbar" }, J = ["onClick", "rowspan", "colspan"], Q = {
  key: 0,
  class: "caret-wrapper"
}, U = { key: 0 }, W = ["colspan"], le = /* @__PURE__ */ V({
  __name: "TanstackTable",
  props: {
    stripe: { type: Boolean, default: !0 },
    border: { type: Boolean, default: !1 },
    tableLayout: { default: "auto" },
    columns: {},
    data: {},
    fixedHead: { type: Boolean, default: !1 },
    multiSelection: { type: Boolean, default: !0 },
    defaultSorter: {},
    expandable: {}
  },
  setup($) {
    const F = k([]);
    let S = k([]), y = k([]);
    const b = {};
    function B(r) {
      if (r.length === 1) return r;
      const i = /* @__PURE__ */ new Set();
      return r.map((n, l, { length: p }) => ({
        ...n,
        headers: n.headers.filter((o) => !i.has(o.column.id)).map((o) => (i.add(o.column.id), o.isPlaceholder ? {
          ...o,
          // If the cell is placeholder(empty), then there will be no subgroup below it,
          // and this means that you can merge it with all lower cells in the column header
          isPlaceholder: !1,
          rowSpan: p - l
        } : { ...o, rowSpan: 1 }))
      }));
    }
    function E(r, i = !1) {
      const n = [], l = [], p = [];
      for (const o of r) {
        const e = {
          ...o
        };
        e.header == null && e.title != null && (e.header = e.title), o.columns == null ? (e.accessorKey == null && e.key != null && (e.accessorKey = e.key), e.enableSorting = !1, e.sortDescFirst = !1, o.cell != null && (e.cell = (t) => o.cell(t.row.original, t.row.index, t)), e.header == null && e.accessorKey != null && (e.header = e.accessorKey), e.id == null && (e.accessorKey != null ? e.id = e.accessorKey : e.header != null && typeof e.header == "string" && (e.id = e.header)), e.fixed === "left" ? l.push(e.id) : e.fixed === "right" && p.push(e.id), e.type != null ? (e.id = e.type, e.type === "selection" && (e.size = 40, a.multiSelection === !1 ? e.cell = ({ row: t }) => c(O, {
          disabled: !t.getCanSelect(),
          checked: t.getIsSelected(),
          onChange: (s) => t.toggleSelected(s)
        }) : (e.header = ({ table: t }) => c(M, {
          checked: t.getIsAllRowsSelected(),
          indeterminate: t.getIsSomeRowsSelected(),
          onChange: (s) => t.toggleAllRowsSelected(s)
        }), e.cell = ({ row: t }) => c(M, {
          checked: t.getIsSelected(),
          disabled: !t.getCanSelect(),
          indeterminate: t.getIsSomeSelected(),
          onChange: (s) => t.toggleSelected(s)
        })))) : i || (i = !0, e.cell = (t) => {
          let s = null;
          o.cell != null && (s = o.cell(
            t.row.original,
            t.row.index,
            t
          )), s == null && (s = t.getValue()), typeof s != "object" && (s = c("span", s));
          const x = [];
          return t.row.depth > 0 && x.push(
            c(
              "div",
              {
                style: {
                  display: "inline-block",
                  width: t.row.depth * 20 + "px"
                }
              },
              ""
            )
          ), t.table.getCanSomeRowsExpand() && x.push(
            c(
              L,
              {
                class: {
                  "nt-table-expand-icon": !0,
                  "nt-table-expand-icon--expanded": t.row.getIsExpanded(),
                  "nt-table-expand-placeholder": !t.row.getCanExpand()
                },
                onClick: t.row.getToggleExpandedHandler()
              },
              {
                default: () => c(T)
              }
            )
          ), x.push(s), x;
        }), e.sorter != null && e.sorter !== !1 && (e.enableSorting = !0, typeof e.sorter == "function" && (e.sortingFn = (t, s) => e.sorter(t.original, s.original))), delete e.title, delete e.key, delete e.fixed) : (e.id == null && e.header != null && typeof e.header == "string" && (e.id = e.header), e.columns = E(e.columns, i).columns), n.push(e);
      }
      if (!i && a.expandable != null) {
        let o = 0;
        n[0].type === "selection" && (o = 1), n.splice(o, 0, {
          id: "expandable",
          cell: (e) => c(
            L,
            {
              class: {
                "nt-table-expand-icon": !0,
                "nt-table-expand-icon--expanded": e.row.getIsExpanded(),
                "nt-table-expand-placeholder": !e.row.getCanExpand()
              },
              onClick: e.row.getToggleExpandedHandler()
            },
            {
              default: () => c(T)
            }
          )
        });
      }
      return { columns: n, leftFixed: l, rightFixed: p };
    }
    const P = (r) => {
      const i = r.id;
      if (i in b)
        return b[i];
      const n = r.getIsPinned(), l = n === "left" && r.getIsLastColumn("left"), p = n === "right" && r.getIsFirstColumn("right"), o = {
        boxShadow: l ? "-4px 0 4px -4px #d9d9d9 inset" : p ? "4px 0 4px -4px #d9d9d9 inset" : void 0,
        left: n === "left" ? `${r.getStart("left")}px` : void 0,
        right: n === "right" ? `${r.getAfter("right")}px` : void 0,
        position: n ? "sticky" : "relative",
        width: `${r.getSize()}px`,
        zIndex: n ? 1 : 0
      };
      return b[i] = o, o;
    }, a = $, w = E(a.columns);
    F.value = w.columns, S.value = w.leftFixed, y.value = w.rightFixed;
    const K = z(() => S.value.length > 0 || y.value.length > 0 ? !0 : a.tableLayout === "fixed"), H = A({
      get data() {
        return a.data;
      },
      columns: F.value,
      getSubRows: (r) => r.children,
      enableMultiRowSelection: a.multiSelection === !0,
      getCoreRowModel: N(),
      getRowCanExpand: (r) => r.original.children != null ? !0 : a.expandable != null ? a.expandable.rowExpandable(r.original) : !1,
      initialState: {
        columnPinning: {
          left: S.value,
          right: y.value
        },
        sorting: a.defaultSorter ? [a.defaultSorter] : void 0
      },
      getSortedRowModel: D(),
      getExpandedRowModel: j()
    });
    return (r, i) => (d(), u("div", q, [
      g("table", {
        class: _([
          "nt-table",
          a.stripe ? "nt-table-stripe" : "",
          K.value ? "nt-table-fixed" : "",
          a.border ? "nt-table-border" : ""
        ])
      }, [
        g("thead", {
          class: _({
            "nt-fixed": a.fixedHead
          }),
          style: C({
            top: a.fixedHead ? "0" : void 0
          })
        }, [
          (d(!0), u(f, null, h(B(m(H).getHeaderGroups()), (n) => (d(), u("tr", {
            key: n.id
          }, [
            (d(!0), u(f, null, h(n.headers, (l) => (d(), u("th", {
              key: l.id,
              style: C(P(l.column)),
              class: _([
                l.column.getCanSort() ? "sort-column" : "",
                l.column.getIsSorted() ? `sort-${l.column.getIsSorted()}` : ""
              ]),
              onClick: (p) => {
                var o;
                return (o = l.column.getToggleSortingHandler()) == null ? void 0 : o(p);
              },
              rowspan: l.rowSpan ? l.rowSpan : 1,
              colspan: l.colSpan
            }, [
              l.isPlaceholder ? v("", !0) : (d(), u(f, { key: 0 }, [
                R(m(I), {
                  render: l.column.columnDef.header,
                  props: l.getContext()
                }, null, 8, ["render", "props"]),
                l.column.getCanSort() ? (d(), u("span", Q, i[0] || (i[0] = [
                  g("span", { class: "sort-caret ascending" }, null, -1),
                  g("span", { class: "sort-caret descending" }, null, -1)
                ]))) : v("", !0)
              ], 64))
            ], 14, J))), 128))
          ]))), 128))
        ], 6),
        g("tbody", null, [
          (d(!0), u(f, null, h(m(H).getRowModel().rows, (n) => (d(), u(f, {
            key: n.id
          }, [
            g("tr", null, [
              (d(!0), u(f, null, h(n.getVisibleCells(), (l) => (d(), u("td", {
                key: l.id,
                style: C(P(l.column))
              }, [
                R(m(I), {
                  render: l.column.columnDef.cell,
                  props: l.getContext()
                }, null, 8, ["render", "props"])
              ], 4))), 128))
            ]),
            r.expandable != null && n.getIsExpanded() ? (d(), u("tr", U, [
              g("td", {
                colspan: n.getAllCells().length
              }, [
                R(m(I), {
                  render: r.expandable.expandedRowRender(n.original),
                  props: null
                }, null, 8, ["render"])
              ], 8, W)
            ])) : v("", !0)
          ], 64))), 128))
        ])
      ], 2)
    ]));
  }
});
export {
  le as _
};
