declare const _default: import('vue').DefineComponent<{
    /** 数据总数 */
    total?: number;
    /** 总页数 */
    pageCount?: number;
    /** 每页显示条目个数 */
    pageSize?: number;
    /** 页码 */
    page?: number;
    /** 默认当前页码 */
    defaultCurrentPage?: number;
    /** 对齐方式 */
    align?: "start" | "center" | "end";
    /** 只有一页时是否隐藏分页器 */
    hideOnSinglePage?: boolean;
    /** 是否为简单分页 */
    simple?: boolean;
}, {}, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {
    change: (...args: any[]) => void;
    "update:page": (...args: any[]) => void;
}, string, import('vue').PublicProps, Readonly<{
    /** 数据总数 */
    total?: number;
    /** 总页数 */
    pageCount?: number;
    /** 每页显示条目个数 */
    pageSize?: number;
    /** 页码 */
    page?: number;
    /** 默认当前页码 */
    defaultCurrentPage?: number;
    /** 对齐方式 */
    align?: "start" | "center" | "end";
    /** 只有一页时是否隐藏分页器 */
    hideOnSinglePage?: boolean;
    /** 是否为简单分页 */
    simple?: boolean;
}> & Readonly<{
    onChange?: ((...args: any[]) => any) | undefined;
    "onUpdate:page"?: ((...args: any[]) => any) | undefined;
}>, {
    pageSize: number;
    defaultCurrentPage: number;
    align: "start" | "center" | "end";
    hideOnSinglePage: boolean;
    simple: boolean;
}, {}, {}, {}, string, import('vue').ComponentProvideOptions, false, {}, any>;
export default _default;
