import { SchemaType } from 'ph-utils/validator';
/**
 * 校验全部表单数据
 */
declare function validate(): void;
/**
 * 校验部分表单数据
 * @param field
 */
declare function validateField(field: string | string[]): void;
declare function clearValidate(): void;
declare function __VLS_template(): {
    slots: {
        default?(_: {}): any;
    };
    refs: {};
    attrs: Partial<{}>;
};
type __VLS_TemplateResult = ReturnType<typeof __VLS_template>;
declare const __VLS_component: import('vue').DefineComponent<{
    /** 表单数据对象 */
    model?: Record<string, any>;
    /** 标签宽度 */
    labelWidth?: string;
    /** 验证规则 */
    rules?: SchemaType[];
    /** 是否行内表单 */
    inline?: boolean;
    disabled?: boolean;
    labelPosition?: "left" | "right" | "top";
}, {
    validate: typeof validate;
    validateField: typeof validateField;
    clearValidate: typeof clearValidate;
}, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {
    submit: (...args: any[]) => void;
}, string, import('vue').PublicProps, Readonly<{
    /** 表单数据对象 */
    model?: Record<string, any>;
    /** 标签宽度 */
    labelWidth?: string;
    /** 验证规则 */
    rules?: SchemaType[];
    /** 是否行内表单 */
    inline?: boolean;
    disabled?: boolean;
    labelPosition?: "left" | "right" | "top";
}> & Readonly<{
    onSubmit?: ((...args: any[]) => any) | undefined;
}>, {
    disabled: boolean;
    inline: boolean;
    labelPosition: "left" | "right" | "top";
}, {}, {}, {}, string, import('vue').ComponentProvideOptions, false, {}, any>;
declare const _default: __VLS_WithTemplateSlots<typeof __VLS_component, __VLS_TemplateResult["slots"]>;
export default _default;
type __VLS_WithTemplateSlots<T, S> = T & {
    new (): {
        $slots: S;
    };
};
