import { defineComponent as b, ref as n, watch as y, onUnmounted as I, computed as S, openBlock as d, createElementBlock as m, Fragment as C, createElementVNode as f, mergeProps as E, normalizeClass as F, normalizeStyle as p, renderSlot as L, createCommentVNode as B, createVNode as D } from "vue";
import { _ as N } from "./ImagePreview.vue_vue_type_script_setup_true_lang-R7Gc1sJb.js";
const V = ["loading", "src", "alt"], P = /* @__PURE__ */ b({
  __name: "Image",
  props: {
    src: {},
    width: {},
    height: {},
    alt: {},
    loading: { default: "eager" },
    fit: {},
    fallback: {},
    placeholder: {},
    previewDisable: { type: Boolean, default: !1 },
    previewSrcList: {},
    initialIndex: { default: 0 },
    customFallback: { type: Boolean, default: !1 }
  },
  setup(h) {
    const o = n(!1), t = n(!1), e = h;
    let a;
    const i = n(e.placeholder || e.src);
    r(), y(
      () => e.src,
      () => {
        i.value = e.placeholder || e.src, r();
      }
    ), I(() => {
      c();
    });
    function r() {
      e.placeholder != null && (a = new Image(), a.src = e.src, a.onload = () => {
        i.value = e.src, c();
      });
    }
    function v() {
      e.previewDisable || (o.value = !0);
    }
    function g() {
      t.value = !1;
    }
    const s = S(() => ({
      width: e.width ? e.width : void 0,
      height: e.height ? e.height : void 0,
      objectFit: e.fit != null ? e.fit : void 0
    }));
    function w(l) {
      e.fallback != null && (l.target.src = e.fallback), t.value = !0;
    }
    function c() {
      a && (a.onload = null, a.onerror = null, a = null);
    }
    return (l, u) => (d(), m(C, null, [
      f("div", E({ class: "nt-image" }, l.$attrs), [
        f("img", {
          loading: l.loading,
          src: i.value,
          class: F([
            "nt-image",
            l.previewDisable ? "" : "nt-image--preview",
            l.customFallback && t.value ? "nt-image-hide" : ""
          ]),
          style: p(s.value),
          alt: l.alt,
          onError: w,
          onClick: v,
          onLoad: g
        }, null, 46, V),
        l.customFallback && t.value ? (d(), m("div", {
          key: 0,
          class: "nt-image",
          style: p(s.value)
        }, [
          L(l.$slots, "fallback")
        ], 4)) : B("", !0)
      ], 16),
      D(N, {
        show: o.value,
        "onUpdate:show": u[0] || (u[0] = (k) => o.value = k),
        "url-list": l.previewSrcList || [l.src],
        "initial-index": l.initialIndex
      }, null, 8, ["show", "url-list", "initial-index"])
    ], 64));
  }
});
export {
  P as _
};
