import { defineComponent as L, mergeModels as g, useModel as x, ref as w, computed as B, watch as b, openBlock as f, createBlock as $, Teleport as I, createVNode as i, Transition as E, withCtx as h, createElementVNode as l, createElementBlock as S, Fragment as z, createCommentVNode as k, normalizeStyle as M } from "vue";
import { _ as N } from "./Close.vue_vue_type_script_setup_true_lang-BCc-M9sH.js";
import { _ as T } from "./ArrowLeft.vue_vue_type_script_setup_true_lang-DLHhQ5In.js";
import { _ as V } from "./ArrowRight.vue_vue_type_script_setup_true_lang-6j7wdDtx.js";
import { _ as O } from "./ZoomIn.vue_vue_type_script_setup_true_lang-BhUjahYn.js";
import { _ as q } from "./ZoomOut.vue_vue_type_script_setup_true_lang-zwbJhpXy.js";
import { _ as D } from "./RefreshLeft.vue_vue_type_script_setup_true_lang-BPhlA46Y.js";
import { _ as F } from "./RefreshRight.vue_vue_type_script_setup_true_lang-D7R94-nU.js";
import { _ as P } from "./Reduction.vue_vue_type_script_setup_true_lang-d68c_CEX.js";
import { _ as R } from "./Shadow.vue_vue_type_script_setup_true_lang-B3BOJC7S.js";
import { g as W } from "./index-DbH20N7R.js";
const Y = { class: "nt-image-preview__btn nt-image-preview__actions" }, j = ["src"], ne = /* @__PURE__ */ L({
  __name: "ImagePreview",
  props: /* @__PURE__ */ g({
    urlList: {},
    initialIndex: { default: 0 }
  }, {
    show: { type: Boolean, required: !0 },
    showModifiers: {}
  }),
  emits: /* @__PURE__ */ g(["close"], ["update:show"]),
  setup(u, { emit: A }) {
    const m = x(u, "show"), y = W(), s = u, a = w(s.initialIndex), n = w({
      /** 缩放 */
      scale: 1,
      /** 旋转 */
      rotate: 0
    }), C = B(() => `scale3d(${n.value.scale}, ${n.value.scale}, 1) rotate3d(0, 0, 1, ${n.value.rotate}deg)`);
    function v(e) {
      _(), e === "prev" ? a.value === 0 ? a.value = s.urlList.length - 1 : a.value-- : a.value === s.urlList.length - 1 ? a.value = 0 : a.value++;
    }
    function o(e) {
      if (e === "in") {
        if (n.value.scale >= 3) return;
        n.value.scale += 0.25;
      } else {
        if (n.value.scale <= 0.25) return;
        n.value.scale -= 0.25;
      }
    }
    function c(e) {
      e === "left" ? n.value.rotate -= 90 : n.value.rotate += 90;
    }
    function _() {
      n.value = {
        scale: 1,
        rotate: 0
      };
    }
    function p() {
      m.value = !1;
    }
    function d(e) {
      e.preventDefault(), e.deltaY > 0 ? o("out") : o("in");
    }
    return b(m, (e) => {
      e ? (document.body.style.overflow = "hidden", document.addEventListener("wheel", d, { passive: !1 })) : (document.body.style.overflow = y, document.removeEventListener("wheel", d));
    }), b(a, (e) => {
      e < 0 ? a.value = 0 : e >= s.urlList.length && (a.value = s.urlList.length - 1);
    }), (e, t) => (f(), $(I, { to: "body" }, [
      i(E, { name: "nt-opacity" }, {
        default: h(() => [
          m.value ? (f(), $(R, {
            key: 0,
            onShadowClick: p,
            "shadow-class": "nt-image-preview-container"
          }, {
            default: h(() => [
              l("span", {
                class: "nt-image-preview__btn nt-image-preview__close",
                "aria-label": "close",
                onClick: p
              }, [
                i(N)
              ]),
              e.urlList.length > 1 ? (f(), S(z, { key: 0 }, [
                l("span", {
                  class: "nt-image-preview__btn nt-image-preview__prev",
                  onClick: t[0] || (t[0] = (r) => v("prev"))
                }, [
                  i(T)
                ]),
                l("span", {
                  class: "nt-image-preview__btn nt-image-preview__next",
                  onClick: t[1] || (t[1] = (r) => v("next"))
                }, [
                  i(V)
                ])
              ], 64)) : k("", !0),
              l("div", Y, [
                l("span", {
                  class: "nt-image-preview__btn",
                  "aria-label": "zoom-out",
                  onClick: t[2] || (t[2] = (r) => o("out"))
                }, [
                  i(q)
                ]),
                l("span", {
                  class: "nt-image-preview__btn",
                  "aria-label": "zoom-int",
                  onClick: t[3] || (t[3] = (r) => o("in"))
                }, [
                  i(O)
                ]),
                l("span", {
                  class: "nt-image-preview__btn",
                  "aria-label": "reset-transform",
                  onClick: _
                }, [
                  i(P)
                ]),
                l("span", {
                  class: "nt-image-preview__btn",
                  "aria-label": "refresh-left",
                  onClick: t[4] || (t[4] = (r) => c("left"))
                }, [
                  i(D)
                ]),
                l("span", {
                  class: "nt-image-preview__btn",
                  "aria-label": "refresh-right",
                  onClick: t[5] || (t[5] = (r) => c("right"))
                }, [
                  i(F)
                ])
              ]),
              l("img", {
                class: "nt-image-preview-img",
                src: e.urlList[a.value],
                style: M({
                  transform: C.value
                })
              }, null, 12, j)
            ]),
            _: 1
          })) : k("", !0)
        ]),
        _: 1
      })
    ]));
  }
});
export {
  ne as _
};
