import { defineComponent as j, useId as q, ref as m, nextTick as F, watch as A, onMounted as G, onUnmounted as H, withDirectives as J, h as i } from "vue";
import { _ as Q } from "./ArrowDown.vue_vue_type_script_setup_true_lang-BsBadE3F.js";
import { _ as W } from "./Popover.vue_vue_type_script_lang-Bu2FmjI_.js";
import X from "./directives/clickoutside.js";
import { _ as Z } from "./Select.vue_vue_type_script_setup_true_lang-B-alIO-K.js";
import { _ as ee } from "./Loading.vue_vue_type_script_setup_true_lang-B8TZA-bM.js";
import { _ as le } from "./MaskClose.vue_vue_type_script_setup_true_lang-DlRPk--3.js";
import { _ as te } from "./Tag.vue_vue_type_script_setup_true_lang-C_9tIsoO.js";
import { e as ae } from "./dom-DkwPuhdr.js";
import { u as ne } from "./useDebounce-C-3_Pz1n.js";
const he = j({
  name: "NtSelect",
  props: {
    /** 提示信息 */
    placeholder: {
      type: String,
      default: "请选择"
    },
    /** 是否禁用 */
    disabled: {
      type: Boolean,
      default: !1
    },
    /** 选项 label 的字段名 */
    labelField: {
      type: String,
      default: "label"
    },
    /** 选项 value 的字段名 */
    valueField: {
      type: String,
      default: "value"
    },
    /** 配置选项内容 */
    options: {
      type: Array,
      default: () => []
    },
    /** 是否多选 */
    multiple: {
      type: Boolean,
      default: !1
    },
    modelValue: {
      type: [String, Number, Array]
    },
    /** 多选时是否将选中值按文字的形式展示 */
    collapseTags: {
      type: Boolean,
      default: !1
    },
    /** 是否可清空 */
    clearable: {
      type: Boolean,
      default: !1
    },
    /** 是否启用过滤 */
    filterable: {
      type: Boolean,
      default: !1
    },
    /** 自定义过滤函数 */
    filter: {
      type: Function
    },
    /** 是否启用远程搜索 */
    remote: {
      type: Boolean,
      default: !1
    },
    /** 是否为加载状态, 通常为远程搜索时使用 */
    loading: {
      type: Boolean,
      default: !1
    }
  },
  emits: ["update:modelValue", "search"],
  setup(t, { attrs: C, emit: h }) {
    const b = q(), c = m(), r = m(!1), p = m(!1), s = m([]), o = m(), d = m(V("")), { run: L, cancel: P } = ne((e) => {
      if (t.remote === !0)
        h("search", e);
      else {
        const l = V(e);
        d.value = l, l.length !== d.value.length && F(() => {
          S();
        });
      }
    }, 300);
    function x(e) {
      let l = e.target, a = !0;
      if (t.multiple)
        do {
          if (l.classList.contains("nt-select-popover")) {
            a = !1;
            break;
          }
          if (l.tagName === "BODY")
            break;
          l = l.parentElement;
        } while (l != null);
      a && c.value != null && (c.value.hide(), r.value = !1, g(), y(!1));
    }
    function I() {
      t.disabled === !1 && c.value != null && (r.value === !0 ? (c.value.hide(), r.value = !1, g(), y(!1)) : (r.value = !0, c.value.show(), y(!0)));
    }
    function y(e = !0) {
      o.value != null && (e ? (o.value.focus(), d.value = V("")) : o.value.blur());
    }
    function _(e = "") {
      o.value != null && (o.value.value = e);
    }
    function $(e) {
      let l = [];
      if (e != null) {
        let a = Array.isArray(e) ? e : [e];
        for (let u = 0, n = a.length; u < n; u++) {
          const f = a[u], O = t.options.find(
            (Y) => Y[t.valueField] === f
          );
          O != null && l.push(O[t.labelField]);
        }
      }
      s.value = l, F(() => {
        t.multiple && r.value && (s.value.length > 0 ? B() : g());
      });
    }
    $(t.modelValue);
    let v;
    A(
      () => t.modelValue,
      (e) => {
        $(e);
      }
    ), A(
      () => t.options,
      (e) => {
        const l = d.value.length;
        d.value = e, e.length !== l && F(() => {
          S();
        });
      }
    ), G(() => {
      v == null && (v = new ResizeObserver(() => {
        S();
      }), v.observe(ae(`#${b}`)[0]));
    }), H(() => {
      v != null && (v.disconnect(), v = void 0), P();
    });
    function S() {
      c.value != null && c.value.updatePosition();
    }
    function D(e) {
      let l = !1, a = t.modelValue;
      return e != null && a != null && (t.multiple === !0 ? l = a.includes(e) : l = e === a), l;
    }
    function V(e) {
      const l = [];
      for (let a = 0, u = t.options.length; a < u; a++) {
        const n = t.options[a];
        let f = !0;
        e && (t.filter != null ? f = t.filter(e, n.value) : f = n[t.labelField].includes(e)), f && l.push(n);
      }
      return l;
    }
    function N(e, l) {
      e.stopPropagation();
      const a = l[t.valueField], u = l[t.labelField];
      let n = t.modelValue;
      if (t.multiple === !0)
        if (n == null)
          n = [a];
        else if (Array.isArray(n)) {
          n = [...n];
          let f = n.indexOf(a);
          f === -1 ? n.push(a) : n.splice(f, 1);
        } else
          n !== a && (n = [n, a]);
      else
        n = a;
      _(t.multiple ? "" : u), o.value != null && (o.value.placeholder = "", o.value.focus()), h("update:modelValue", n);
    }
    function T() {
      let e = d.value.map((l) => {
        const a = D(l[t.valueField]);
        return i(
          "li",
          {
            class: [
              "nt-select-option",
              l.class,
              a ? "nt-select-option--selected" : void 0
            ],
            onClick: (u) => N(u, l)
          },
          [
            l.render == null ? i("span", l[t.labelField]) : l.render(l, a, t.modelValue),
            a ? i(Z) : void 0
          ]
        );
      });
      return (e == null || e.length === 0) && e.push(
        i("li", { class: "nt-select-option nt-select-option--empty" }, [
          i("span", "无数据")
        ])
      ), e;
    }
    function k(e) {
      let l = [...t.modelValue];
      l.splice(e, 1), h("update:modelValue", l), l.length === 0 && o.value != null && (o.value.placeholder = t.placeholder);
    }
    function M(e) {
      t.multiple ? h("update:modelValue", []) : h("update:modelValue", void 0), g(), e.stopPropagation();
    }
    function B() {
      s.value.length > 0 && t.clearable && (p.value = !0);
    }
    function g() {
      t.clearable && p.value && (p.value = !1);
    }
    function w(e, l = 0, a = !0) {
      return i(
        te,
        {
          closable: a,
          type: "info",
          onClose: (u) => {
            k(l), u.stopPropagation();
          },
          class: "nt-select-item"
        },
        { default: () => e }
      );
    }
    function z(e) {
      const l = e.target;
      l.value !== "" && (l.placeholder = l.value, l.value = ""), s.value.length > 0 && (l.placeholder = "");
    }
    function K() {
      s.value.length > 0 && !t.multiple ? _(s.value[0]) : _("");
    }
    function E(e) {
      const l = e.target;
      L(l.value);
    }
    function R(e) {
      let l = s.value.length;
      e.key === "Backspace" && l > 0 && k(l - 1);
    }
    function U() {
      const e = [];
      let l = s.value.length;
      if (l > 0)
        if (!t.multiple)
          t.filterable || e.push(
            i("span", { class: "nt-select-item" }, s.value[0])
          );
        else if (t.collapseTags)
          e.push(w(s.value[0])), l > 1 && e.push(w(`+${l - 1}`, 0, !1));
        else
          for (let a = 0; a < l; a++) {
            const u = s.value[a];
            e.push(w(u, a));
          }
      else
        t.filterable || e.push(
          i(
            "span",
            { class: "nt-select-item nt-select-placeholder" },
            t.placeholder
          )
        );
      return t.filterable && e.push(
        i(
          "div",
          { class: "nt-select-item nt-select-search" },
          i("input", {
            class: "nt-select--input",
            placeholder: t.placeholder,
            ref: o,
            onFocus: z,
            onBlur: K,
            onInput: E,
            onKeydown: R
          })
        )
      ), e;
    }
    return () => [
      J(
        i(
          "div",
          {
            ...C,
            class: [
              "nt-select",
              r.value ? "nt-select--active" : void 0,
              C.class
            ],
            id: b,
            onClick: I,
            onMouseenter: B,
            onMouseleave: g
          },
          [
            i("div", { class: "nt-select-main" }, U()),
            i(Q, {
              class: [
                "nt-select--arrow",
                r.value ? "nt-expanded" : void 0
              ]
            }),
            p.value ? i(le, {
              class: "nt-select--clear",
              onClick: M
            }) : void 0,
            t.loading ? i(ee, {
              class: "nt-select--loading nt-rotate-anim"
            }) : void 0
          ]
        ),
        [[X, x]]
      ),
      i(
        W,
        {
          ref: c,
          trigger: "manual",
          reference: `#${b}`,
          width: "trigger",
          placement: "bottom",
          showArrow: !1,
          offset: 2,
          class: "nt-select-popover"
        },
        {
          default: () => i(
            "div",
            { class: "nt-select-list nt-scrollbar" },
            i("ul", T())
          )
        }
      )
    ];
  }
});
export {
  he as _
};
