import { defineComponent as _, ref as w, watch as A, h as u, toRaw as F } from "vue";
import { isBlank as L, random as q } from "ph-utils";
import { f as N } from "./date-q_dW_M_q.js";
function D(t, a) {
  let o = 0;
  const c = a.length;
  let h = !1;
  for (let d = 0; d < c; d++) {
    const p = a[d];
    if (p[0] === t) {
      d === 0 && (h = !0);
      break;
    }
    o += p[1];
  }
  return { start: o, isFirst: h };
}
function K(t, a) {
  let o = 0, c = !1;
  const h = a.length;
  for (let d = h - 1; d >= 0; d--) {
    const p = a[d];
    if (p[0] === t) {
      d === h - 1 && (c = !0);
      break;
    }
    o += p[1];
  }
  return { start: o, isFirst: c };
}
function R(t, a = 0, o, c) {
  const h = [];
  for (let d = 0, p = t.length; d < p; d++) {
    const i = t[d];
    if (i.id == null && (i.id = i.key || i.title), L(i.id) && (i.id = q(6)), i.fixed != null) {
      const y = Number.parseInt(`${i.width || 0}`);
      i.fixed === "left" ? o.push([i.id, y]) : i.fixed === "right" && c.push([i.id, y]);
    }
    if (i.children != null) {
      let y = i.titleColspan;
      const b = R(
        i.children,
        a + 1,
        o,
        c
      );
      y == null && (y = b.reduce(
        (g, k) => g + (k.titleColspan || 0),
        0
      )), h.push({
        ...i,
        titleColspan: y,
        titleRowspan: i.titleRowspan || 1,
        children: b
      });
    } else {
      let y = i.titleRowspan;
      y == null && (y = H(t)), h.push({
        ...i,
        titleColspan: i.titleColspan || 1,
        titleRowspan: y
      });
    }
  }
  return h;
}
function H(t) {
  let a = 1;
  return t.forEach((o) => {
    if (o.children) {
      const c = H(o.children) + 1;
      c > a && (a = c);
    }
  }), a;
}
const M = _({
  props: {
    columns: {
      type: Array,
      required: !0
    },
    /** 创建带斑马纹的表格 */
    stripe: {
      type: Boolean,
      default: !0,
      required: !1
    },
    /** 是否显示四周边框 */
    border: {
      type: Boolean,
      default: !1,
      required: !1
    },
    /** 是否固定表头 */
    fixedHead: {
      type: Boolean,
      default: !1,
      required: !1
    },
    data: {
      type: Array,
      required: !0
    },
    defaultSort: {
      type: Object,
      required: !1
    },
    sorter: {
      type: Function,
      required: !1
    },
    /** 渲染表尾合计行 */
    renderSummary: {
      type: Function,
      required: !1
    },
    /** 是否使用 fixed[table-layout:fixed] 布局 */
    tableLayout: {
      type: String,
      required: !1,
      default: "auto"
    },
    rowKey: {
      type: Function,
      required: !1
    }
  },
  emits: ["select-change"],
  setup(t) {
    const a = w({
      key: "",
      order: ""
    }), o = w(t.data), c = {}, h = [], d = [], p = w(!1), i = R(
      t.columns,
      0,
      h,
      d
    );
    p.value = h.length > 0 || d.length > 0;
    function y(e, r, s) {
      const l = e.id;
      if (l in c)
        return c[l];
      const f = { ...e.style };
      if (e.width != null && (typeof e.width == "number" ? f.width = `${e.width}px` : f.width = e.width), e.fixed != null) {
        let n = { start: 0, isFirst: !1 };
        e.fixed === "left" ? (n = D(l, r), f.boxShadow = "-4px 0 4px -4px #d9d9d9 inset", f.left = `${n.start}px`) : e.fixed === "right" && (n = K(l, s), f.boxShadow = "4px 0 4px -4px #d9d9d9 inset", f.right = `${n.start}px`);
      }
      return c[l] = f, f;
    }
    A(
      () => t.data,
      () => {
        o.value = t.data;
      }
    );
    function b(e, r, s) {
      let l = [...e];
      return s ? s(l, F(r)) : r.key === "" ? l : l.sort((f, n) => r.order === "asc" ? f[r.key] >= n[r.key] ? 1 : -1 : f[r.key] >= n[r.key] ? -1 : 1);
    }
    t.defaultSort != null && (a.value = {
      key: t.defaultSort.key,
      order: t.defaultSort.order
    }, o.value = b(t.data, a.value, t.sorter));
    function g({ sorter: e, key: r }) {
      if (e === !0) {
        let s = r, l = "";
        r === a.value.key ? a.value.order === "asc" ? l = "desc" : s = "" : l = "asc", a.value = {
          order: l,
          key: s
        }, o.value = b(t.data, a.value, t.sorter);
      }
    }
    function k(e, r) {
      const s = {
        class: {
          "sort-column": e.sorter === !0,
          "sort-asc": a.value.key === e.key && a.value.order === "asc",
          "sort-desc": a.value.key === e.key && a.value.order === "desc",
          "nt-fixed": e.fixed
        },
        style: y(e, h, d),
        colspan: e.titleColspan,
        rowspan: e.titleRowspan
      };
      e.sorter === !0 && (s.onClick = () => {
        g({
          key: e.key || "",
          index: r,
          order: "asc",
          sorter: e.sorter
        });
      });
      const l = [];
      return l.push(u("span", e.title)), e.sorter === !0 && l.push(
        u("span", { class: "caret-wrapper" }, [
          u("span", { class: "sort-caret ascending" }),
          u("span", { class: "sort-caret descending" })
        ])
      ), u("th", s, l);
    }
    function S(e, r, s) {
      for (let l = 0, f = e.length; l < f; l++) {
        const n = e[l];
        if (r.push(k(n, l)), n.children != null) {
          let x = [];
          S(n.children, x, s), s.push(u("tr", x));
        }
      }
    }
    function $() {
      const e = [], r = [];
      return S(i, r, e), e.unshift(u("tr", r)), e;
    }
    function C(e, r, s, l, f) {
      for (const n of e)
        if (n.children == null) {
          let x = null, v = null;
          if (typeof n.rowspan == "number" && (x = n.rowspan), typeof n.rowspan == "function" && (x = n.rowspan(s, r)), typeof n.colspan == "number" && (x = n.colspan), typeof n.colspan == "function" && (v = n.colspan(s, r)), x !== 0 && v !== 0) {
            const m = {
              style: y(n, h, d),
              class: [n.fixed ? "nt-fixed" : void 0, n.class],
              colspan: v,
              rowspan: x
            };
            n.render != null ? l.push(
              u("td", m, n.render(s, r))
            ) : n.key != null ? l.push(u("td", m, s[n.key])) : l.push(u("td", m, ""));
          }
        } else
          C(
            n.children,
            r,
            s,
            l
          );
    }
    function B() {
      const e = [];
      N(), `${q(3)}${String(Date.now()).substring(8)}`;
      for (let r = 0, s = o.value.length; r < s; r++) {
        const l = o.value[r], f = [];
        C(i, r, l, f), e.push(u("tr", f));
      }
      return e;
    }
    return () => u(
      "div",
      { class: "nt-table-wrapper" },
      u(
        "table",
        {
          class: [
            "nt-table",
            t.stripe ? "nt-table-stripe" : "",
            p.value || t.tableLayout === "fixed" ? "nt-table-fixed" : "",
            t.border ? "nt-table-border" : ""
          ]
        },
        [
          u(
            "thead",
            {
              class: {
                "nt-fixed": t.fixedHead
              },
              style: {
                top: t.fixedHead ? "0" : void 0
              }
            },
            $()
          ),
          u(
            "tbody",
            t.data.length === 0 ? u(
              "td",
              {
                class: "nt-table__none-col",
                colspan: t.columns.length
              },
              "暂无数据记录!"
            ) : B()
          ),
          t.renderSummary ? u(
            "tfoot",
            { class: "nt-fixed", style: { bottom: "0" } },
            t.renderSummary()
          ) : null
        ]
      )
    );
  }
});
export {
  M as _
};
