import { defineComponent as k, ref as a, onMounted as b, openBlock as o, createElementBlock as u, createElementVNode as h, normalizeStyle as m, renderSlot as S, Fragment as x, renderList as F, normalizeClass as $ } from "vue";
const M = /* @__PURE__ */ k({
  __name: "VirtualList",
  props: {
    items: {},
    itemSize: {},
    itemClass: { default: "" },
    keyField: {},
    buffer: { default: 2 }
  },
  setup(z) {
    const e = z, l = a(), s = a([]), c = a(0), d = a(0);
    let f = 0, v = -1;
    function p() {
      if (l.value != null) {
        const t = l.value.scrollTop;
        let n = Math.floor(t / e.itemSize), i = Math.max(0, n - e.buffer);
        const r = Math.min(
          e.items.length,
          n + f + e.buffer
        );
        let g = t - t % e.itemSize;
        s.value = e.items.slice(i, r), d.value = g - (n - i) * e.itemSize;
      }
    }
    function y() {
      cancelAnimationFrame(v), v = requestAnimationFrame(() => {
        p();
      });
    }
    return b(() => {
      if (c.value = e.itemSize * e.items.length, l.value != null) {
        let t = l.value.getBoundingClientRect();
        f = Math.ceil(t.height / e.itemSize), p();
      }
    }), (t, n) => (o(), u("div", {
      class: "nt-virtual-list",
      ref_key: "$list",
      ref: l,
      onScrollPassive: y
    }, [
      h("div", {
        style: m({ height: `${c.value}px` })
      }, [
        h("div", {
          style: m({ transform: `translate3d(0px, ${d.value}px, 0px)` })
        }, [
          S(t.$slots, "render", { data: s.value }, () => [
            (o(!0), u(x, null, F(s.value, (i, r) => (o(), u("div", {
              style: m({ height: e.itemSize + "px" }),
              key: t.keyField != null ? i[t.keyField] : r,
              class: $(["nt-virtual-item", t.itemClass])
            }, [
              S(t.$slots, "default", { item: i })
            ], 6))), 128))
          ])
        ], 4)
      ], 4)
    ], 544));
  }
});
export {
  M as _
};
