const d = /rgba?\s*\(\s*(\d{1,3})\s*,\s*(\d{1,3})\s*,\s*(\d{1,3})(?:\s*,\s*(\d*\.?\d+))?\s*\)/, p = /^#(?:([0-9A-Fa-f]{2})([0-9A-Fa-f]{2})([0-9A-Fa-f]{2})|([0-9A-Fa-f]{1})([0-9A-Fa-f]{1})([0-9A-Fa-f]{1}))$/;
function S(t) {
  return t.r != null && t.g != null && t.b != null;
}
function g(t) {
  return t.h != null && t.s != null && t.v != null;
}
function M(t) {
  let e = t.match(d);
  if (e != null) {
    const r = parseInt(e[1].trim()), n = parseInt(e[2].trim()), u = parseInt(e[3].trim());
    if (isNaN(r) || isNaN(n) || isNaN(u))
      throw new Error("Invalid RGB color.");
    let s = 1;
    return e[4] != null && (s = parseFloat(e[4].trim()), isNaN(s) && (s = 1)), {
      r,
      g: n,
      b: u,
      a: s
    };
  }
}
function m(t) {
  const e = t.match(p);
  if (e != null) {
    const r = e[4] !== void 0, n = parseInt(r ? e[4] + e[4] : e[1], 16), u = parseInt(r ? e[5] + e[5] : e[2], 16), s = parseInt(r ? e[6] + e[6] : e[3], 16);
    return {
      r: n,
      g: u,
      b: s
    };
  }
}
function h(t) {
  if (typeof t == "string") {
    let e = m(t);
    if (e == null && (e = M(t)), e != null)
      return e;
    throw new Error("Invalid color string");
  } else {
    if (S(t))
      return t;
    if (g(t))
      return F(t);
    throw new Error("Invalid color");
  }
}
function x(t) {
  if (g(t))
    return t;
  const e = h(t), r = e.r / 255, n = e.g / 255, u = e.b / 255;
  let s = Math.max(r, n, u), o = Math.min(r, n, u), c = s - o, l = s, i = s === 0 ? 0 : c / s, a = 0;
  if (s === o)
    a = 0;
  else
    switch (s) {
      case r:
        a = ((n - u) / c + (n < u ? 6 : 0)) / 6;
        break;
      case n:
        a = ((u - r) / c + 2) / 6;
        break;
      case u:
        a = ((r - n) / c + 4) / 6;
        break;
    }
  return a = a * 360, { h: a, s: i, v: l };
}
function F(t) {
  let e = t.s, r = t.v;
  e > 1 && (e /= 100), r > 1 && (r /= 100);
  const n = t.h;
  var u = Math.floor(n / 60) % 6, s = n / 60 - Math.floor(n / 60), o = r * (1 - e), c = r * (1 - s * e), l = r * (1 - (1 - s) * e);
  let i = 0, a = 0, f = 0;
  switch (u) {
    case 0:
      i = r, a = l, f = o;
      break;
    case 1:
      i = c, a = r, f = o;
      break;
    case 2:
      i = o, a = r, f = l;
      break;
    case 3:
      i = o, a = c, f = r;
      break;
    case 4:
      i = l, a = o, f = r;
      break;
    case 5:
      i = r, a = o, f = c;
      break;
  }
  return i = Math.round(i * 255), a = Math.round(a * 255), f = Math.round(f * 255), { r: i, g: a, b: f };
}
function N(t, e, r) {
  let n;
  return Math.round(t.h) >= 60 && Math.round(t.h) <= 240 ? n = r ? Math.round(t.h) - 2 * e : Math.round(t.h) + 2 * e : n = r ? Math.round(t.h) + 2 * e : Math.round(t.h) - 2 * e, n < 0 ? n += 360 : n >= 360 && (n -= 360), n;
}
function k(t, e, r) {
  if (t.h === 0 && t.s === 0)
    return t.s;
  let n;
  return r ? n = t.s - 0.16 * e : n = t.s + 0.05 * e, n > 1 && (n = 1), n < 0.06 && (n = 0.06), Number(n.toFixed(2));
}
function I(t, e, r) {
  let n;
  return r ? n = t.v + 0.05 * e : n = t.v - 0.15 * e, n > 1 && (n = 1), Number(n.toFixed(2));
}
function b(t) {
  const e = (r) => r.toString(16).padStart(2, "0");
  return `#${e(t.r)}${e(t.g)}${e(t.b)}`.toUpperCase();
}
function w(t) {
  return typeof t == "string" && p.test(t) ? t : b(h(t));
}
function H(t, e = 1, r = !0) {
  const n = x(t);
  return w({
    h: N(n, e, r),
    s: k(n, e, r),
    v: I(n, e, r)
  });
}
export {
  H as a
};
