import { defineComponent as b, inject as f, computed as k, h as t } from "vue";
import { _ as m } from "../../_plugin-vue_export-helper-CHgC5LLL.js";
const r = b({
  props: {
    /** 设置不确定状态，仅负责样式控制 */
    indeterminate: {
      type: Boolean,
      default: !1
    },
    disabled: {
      type: Boolean,
      default: !1
    },
    /** 显示的 label 文本 */
    label: String,
    value: {
      type: [String, Number, Boolean],
      default: void 0
    },
    type: String,
    checked: { type: Boolean, default: void 0 },
    /** 原生 name 属性 */
    name: String,
    modelValue: {
      type: Boolean,
      default: !1
    }
  },
  emits: ["change", "update:modelValue"],
  setup(e, { emit: n, slots: l }) {
    const { checkList: a, updateCheck: c } = f("nt-checkbox-group-check", {
      checkList: null,
      updateCheck: null
    }), u = k(() => a != null ? a.value.includes(e.value) : e.value != null ? e.modelValue === e.value : e.checked != null ? e.checked : e.modelValue);
    function i(o) {
      const h = o.target.checked;
      c != null && c(e.value);
      const d = e.value == null ? h : e.value;
      n("update:modelValue", d), n("change", d);
    }
    return () => t(
      "label",
      {
        class: [
          "nt-checkbox",
          e.indeterminate ? "nt-checkbox--indeterminate" : "",
          e.disabled ? "nt-checkbox--disabled" : "",
          e.type === "button" ? "nt-checkbox--button" : ""
        ]
      },
      [
        t("input", {
          type: "checkbox",
          class: "nt-checkbox__input",
          name: e.name,
          checked: u.value,
          onChange: i,
          disabled: e.disabled,
          value: e.value
        }),
        e.type !== "button" ? t("span", { class: "nt-checkbox__inner" }) : null,
        l.default != null || e.label != null ? t(
          "span",
          { class: "nt-checkbox__label" },
          l.default != null ? l.default() : e.label
        ) : null
      ]
    );
  }
});
function s(e, n, l, a, c, u) {
  return null;
}
const g = /* @__PURE__ */ m(r, [["render", s]]);
export {
  g as default
};
