type MessageOption = {
    showCancel?: boolean;
    type?: string;
};
declare function alert(message: string, title?: string, option?: MessageOption): Promise<unknown>;
declare function confirm(message: string, title?: string, option?: MessageOption): Promise<unknown>;
declare function prompt(tip: string, title?: string): Promise<unknown>;
declare const _default: {
    alert: typeof alert;
    confirm: typeof confirm;
    prompt: typeof prompt;
};
export default _default;
