const e = {
  /** 触发方式: hover - 渲染, click - 点击, manual - 非受控模式, 手动展开 */
  trigger: {
    type: String,
    default: "hover"
  },
  /** 显示的内容，也可以通过写入默认 slot 修改显示内容 */
  content: String,
  /** 弹出位置 */
  placement: {
    type: String,
    default: "top"
  },
  /** 受控模式时对应的节点 */
  reference: [Object, String],
  /** 是否显示箭头 */
  showArrow: {
    type: Boolean,
    default: !0
  },
  /** 是否不能激活弹出信息 */
  disabled: {
    type: Boolean,
    default: !1
  },
  /** 宽度, 'trigger' 表示 popover 的宽度会和它的触发元素一致 */
  width: {
    type: [String, Number],
    default: void 0
  },
  /** 浮层偏移量 */
  offset: {
    type: Number,
    default: 10
  },
  /** 是否在隐藏时删除节点, 如果为 true 则删除, 否则只是设置 display: none */
  destroyOnHide: {
    type: Boolean,
    default: !1
  }
};
export {
  e as popoverProps
};
