import { Ref } from 'vue';
/**
 * 数据重置, 通常用于表单
 *
 * @param params 表单数据
 * @returns
 */
export default function useFormReset<T>(params: T): {
    formFields: Ref<T, T>;
    resetFields: () => void;
    setFields: {
        (key: string, value: any): void;
        (values: Record<string, any>): void;
    };
};
